//Nightlight- a cool mode if you just want to walk around with it being overwhelming.
void nightlight(){
  uint16_t i, j, q;
  for (j=0; j<8; j++){strip.setPixelColor(j*17, strip.Color(10,10,10));}  strip.show();
  for (j=0; j<8; j++){strip.setPixelColor(j*17+16, strip.Color(5,5,5));}  strip.show();
 }  
 
//Randomly turn on LEDs until all are turned on- I'm sure there is a better way to store this, but it works for me.
// I made an out so you don't have to sit and wait for it to find all of them (takes about 4 minutes to hit all the pixels
void myrandom(uint16_t tries, uint16_t only60) {
    int wait = 10;     boolean myarray[136];
    for (uint16_t z=0; z<136; z++){myarray[z]=0;}  //Filled the array
    uint16_t total=0;
    delay (1000);
    //Start of the cycler
    for(uint16_t i=0; i<tries; i++) {
      int red = random(200);  int green = random(200);  int blue = random(200);
      int j = random(strip.numPixels());      // get a random pixel from the list      
      myarray[j] = 1;                        //Store the random number into the array
      total=0;
      for (uint16_t k=0; k<136; k++){   if(myarray[k] == 1){total++;}   }      
      
      //If you fill the umbrella or hit the 60
      if (total>135){colorWipe(strip.Color(0,0,0),0); tries=0;}
      if (total>only60){
        for (uint16_t z=0; z<136; z++){
          if(myarray[z]==1){
            myarray[z]=0;strip.setPixelColor(z, strip.Color(0, 0, 0));
          }
        }
      }  
            
      //Put the colorful things up & then fade them a little
        strip.setPixelColor(j, strip.Color(red, green, blue));  strip.show();        delay(wait);
        int r=red;  int g=green;  int b=blue;
        for (int x=4; x >= 0; x--) {
          strip.setPixelColor(j, strip.Color(r, g, b));  r = round(r/2);  g = round(g/2);         b = round(b/2); strip.show();    delay(2);
        }      
    }
}

//My version of Rain Drops. It's not bad. I played with it a bit. Changing the acceleration does funny things though.
void trickle(uint16_t number){
  int spine, start, count, accel, realdrop;  int droptime=30;  int wait=50;
  
    for (uint16_t i=0; i<number; i++){
       spine=random(7);     start=random(16);  droptime=random(100);  wait=random(100); accel=(80+random(20))/100;  count=16-start;      
       realdrop=10+droptime;
       
       for (count; count >=0; count--){
         strip.setPixelColor(spine*17+count, strip.Color(30,10,70)); strip.show();  realdrop=realdrop*accel;
         delay(realdrop);  strip.setPixelColor(spine*17+count, strip.Color(0,0,0));   strip.show();
       }
       delay (20);
   }
}

//Add Color to an entire level. then delete and move to the next level. all the way up and down
void leveler(){
  uint16_t i, j, q;
  for(i=0; i<17;) {
      for (j=0; j<8; j++){strip.setPixelColor(j*17+i, strip.Color(0,75,0));}  strip.show();  delay (600);
      for (j=0; j<8; j++){strip.setPixelColor(j*17+i+1, strip.Color(0,0,75));}  strip.show();  delay (600);
      i=i+4;
 }  
 delay (1000);
}

//Alternates between colors for each layer; for some reason my code was having problems so I just made it simpler
//looks like a police car
void rotator(){
  uint16_t i, j, q;
  for(i=0; i<17;i++){
      for (j=0; j<8; j=j+2){strip.setPixelColor(j*17+i, strip.Color(100,10,0));}  strip.show();  delay (70);
      for (j=0; j<8; j=j+2){strip.setPixelColor(j*17+i, strip.Color(255,0,0));}  strip.show();  delay (70);
      for (j=0; j<8; j=j+2){strip.setPixelColor(j*17+i, strip.Color(0,0,0));      strip.show();}  
      for (j=1; j<8; j=j+2){strip.setPixelColor(j*17+i, strip.Color(0,10,100));}  strip.show();  delay (70);
      for (j=1; j<8; j=j+2){strip.setPixelColor(j*17+i, strip.Color(0,0,255));}  strip.show();  delay (70);
      for (j=1; j<8; j=j+2){strip.setPixelColor(j*17+i, strip.Color(0,0,0));      strip.show();}
 }  
}

//Goes through every possible color and shoots them to the sky;  looks similar to fireworks, a slight failure in my mind.
//I wanted to be able to give it a time in second and have it run the color spectrum in that amount of time, but I gave up.
void everyColor(){
  uint16_t i, j, q, r, multiplier; r=0;  multiplier=24;//16*16*16=4096=38s; 

  for (i=0; i<256; i=i+multiplier){
    for (j=0; j<256; j=j+multiplier){
       for (q=0; q<256; q=q+multiplier){
           if (r>136){r=0;}
           strip.setPixelColor(r,strip.Color(i,j,q));  strip.show();  strip.setPixelColor(r,strip.Color(0,0,0));  r++;
           delay(12);  
       }  
    } 
  }
}

//Removes 1/2 of the tops then half of the bottoms; another poor way to code it, but I was having problems with some loops
//I spent way too long playing with this. Loops of loops tend to drive me crazy.
void chunker(){
  int wait= 700;
      uint16_t i, q;
     //Removes from the bottom
     
    q=0;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=1;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (2000);

    q=2;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=3;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);

    q=4;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=5;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);

    q=6;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=7;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);

    q=1;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=0;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);

    q=3;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=2;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);

    q=5;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=4;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);

    q=7;  for (i=0; i<9; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
    q=6;  for (i=9; i<17; i++){strip.setPixelColor(q*17+i, strip.Color(0,0,0));}  strip.show();  delay (wait);
}

//Spirals a single pixel on the way up, and a ton on the way down- probably one of my favorite ones; it moves so fast it doesn't look like a spiral though.
void spiral(){
  uint16_t i, j;

   //Go Up
   for(i=0; i<17; i++) {      
     for (j=0; j<8; j++){
       strip.setPixelColor(j*17+i, strip.Color(255,255,255));  strip.setBrightness(j*20+10); //adjust brightness here (original is 80)
       strip.show();    delay (10);  strip.setPixelColor(j*17+i, strip.Color(0,0,0)); 
     }           
   }  
   //Go down
   for(i=1; i<18; i++) {      
     for (j=0; j<8; j++){
       strip.setPixelColor(136-(j*17+i), strip.Color(255,255,255));  strip.setBrightness(j*20+10);strip.show();
       strip.setPixelColor(136-(j*17+i), strip.Color(0,0,0));
     }           
   }  
}
